'use strict';var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}var CONTAINER_CLASS='multi-checkbox-list-container';var LIST_CLASS='multi-checkbox-list-list';var ENTRY_LIST_TITLE_CLASS='multi-checkbox-list-title';var ENTRY_CLASS='multi-checkbox-list-entry';var ENTRY_LIST_CLASS='multi-checkbox-list-entry-list';var SELECTED_TITLE_CLASS='multi-checkbox-list-selected-title';var SELECTED_ENTRY_CLASS='multi-checkbox-list-selected-entry';var SELECTED_LIST_CLASS='multi-checkbox-list-selected-entry-list';var MultiCheckboxList=function(){function MultiCheckboxList(selector){var options=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};_classCallCheck(this,MultiCheckboxList);this.setOptions(options);this.buildGui(selector);this.addCheckboxes(selector.getElementsByTagName('option'));}_createClass(MultiCheckboxList,[{key:'setOptions',value:function setOptions(options){options.listTitle=options.listTitle!==undefined?options.listTitle:'Available options';options.selectedList=options.selectedList!==undefined?options.selectedList:false;options.selectedTitle=options.selectedTitle!==undefined?options.selectedTitle:"Selected options";options.entries=options.entries!==undefined?options.entries:[];this.options=options;this.listeners={'select':[],'deselect':[]};}},{key:'buildGui',value:function buildGui(selectElement){var self=this;selectElement.style.display='none';this.containerDiv=document.createElement('div');this.containerDiv.classList.add(CONTAINER_CLASS);selectElement.parentNode.insertBefore(this.containerDiv,selectElement);var listContainer=document.createElement('div');listContainer.classList.add(LIST_CLASS);this.containerDiv.appendChild(listContainer);this.headerListDiv=document.createElement('div');this.headerListDiv.innerHTML=this.options.listTitle;this.headerListDiv.classList.add(ENTRY_LIST_TITLE_CLASS);listContainer.appendChild(this.headerListDiv);this.optionListDiv=document.createElement('div');this.optionListDiv.classList.add(ENTRY_LIST_CLASS);listContainer.appendChild(this.optionListDiv);if(this.options.selectedList){var selectedContainer=document.createElement('div');selectedContainer.classList.add(LIST_CLASS);this.containerDiv.appendChild(selectedContainer);this.selectedHeaderListDiv=document.createElement('div');this.selectedHeaderListDiv.innerHTML=this.options.selectedTitle;this.selectedHeaderListDiv.classList.add(SELECTED_TITLE_CLASS);selectedContainer.appendChild(this.selectedHeaderListDiv);this.selectedOptionListDiv=document.createElement('div');this.selectedOptionListDiv.classList.add(SELECTED_LIST_CLASS);selectedContainer.appendChild(this.selectedOptionListDiv);this.addListener("select",function(element){self.addSelectedEntry(element);for(var i=0;i<self.options.entries.length;i++){var option=self.options.entries[i];if(option.value===element.value){option.selected=true;}}});this.addListener("deselect",function(element){var nodes=self.selectedOptionListDiv.childNodes;for(var i=nodes.length-1;i>=0;i--){if(nodes[i].innerHTML===element.name){self.selectedOptionListDiv.removeChild(nodes[i]);}}for(var _i=0;_i<self.options.entries.length;_i++){var option=self.options.entries[_i];if(option.value===element.value){option.selected=false;}}});}}},{key:'addSelectedEntry',value:function addSelectedEntry(entry){if(this.options.selectedList){var selectedDiv=document.createElement("div");selectedDiv.innerHTML=entry.name;selectedDiv.classList.add(SELECTED_ENTRY_CLASS);this.selectedOptionListDiv.appendChild(selectedDiv);}}},{key:'addCheckboxes',value:function addCheckboxes(htmlOptions){for(var i=0;i<this.options.entries.length;i++){var option=this.options.entries[i];this.optionListDiv.appendChild(this.createCheckboxEntry(option.value,option.name,option.selected));}for(var _i2=0;_i2<htmlOptions.length;_i2++){var _option=htmlOptions[_i2];var value=_option.value;var name=_option.innerHTML;this.options.entries.push({value:value,name:name,selected:false});this.optionListDiv.appendChild(this.createCheckboxEntry(value,name));}}},{key:'createCheckboxEntry',value:function createCheckboxEntry(value,name,selected){var self=this;var checkboxDivContainer=document.createElement('div');checkboxDivContainer.classList.add(ENTRY_CLASS);var checkbox=document.createElement('input');checkbox.type='checkbox';checkbox.value=value;if(selected){checkbox.checked=true;self.addSelectedEntry({value:value,name:name});}checkbox.onchange=function(){var name=void 0;for(var i=0;i<checkbox.parentNode.childNodes.length;i++){var node=checkbox.parentNode.childNodes[i];if(node.nodeName.toLowerCase()==="div"){name=node.innerHTML;}}if(this.checked){return self.callListeners('select',{value:this.value,name:name});}else{return self.callListeners('deselect',{value:this.value,name:name});}};checkboxDivContainer.appendChild(checkbox);var description=document.createElement('div');description.innerHTML=name;checkboxDivContainer.appendChild(description);return checkboxDivContainer;}},{key:'getSelected',value:function getSelected(){var result=[];var checkboxes=this.optionListDiv.getElementsByTagName('input');for(var i=0;i<checkboxes.length;i++){var checkbox=checkboxes[i];if(checkbox.checked){result.push(checkbox.value);}}return result;}},{key:'addListener',value:function addListener(type,listener){if(this.listeners[type]===undefined){throw new Error('Unknown listener type: '+type);}this.listeners[type].push(listener);}},{key:'callListeners',value:function callListeners(type,element){if(this.listeners[type]===undefined){throw new Error('Unknown listener type: '+type);}var results=[];for(var i=0;i<this.listeners[type].length;i++){results.push(this.listeners[type][i](element));}return Promise.all(results);}}]);return MultiCheckboxList;}();module.exports=MultiCheckboxList;